#!/bin/bash

source genLib.sh

function texLimitTableOpen() {
	local caption="$1"
	
	echo "\\begin{table}[!bp]"
 	echo "\\centering"
    echo "\\begin{minipage}{0.85\\textheight}"
    echo "\\def\\arraystretch{0.9}"
	echo "      \\small\\centering"
	echo "      \\setlength{\\tabcolsep}{1.0mm}"
	echo "      \\scriptsize"
	echo "      \\centering"
	echo "      \\caption{$caption}"
#    echo "  \\label{my-label}" 
	echo "\\begin{tabular}{|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "}"
	echo "\\hline"
	echo "\\multirow{2}{*}{\\textbf{\\begin{tabular}[c]{@{}l@{}}Frm\\\\ Size\\end{tabular}}}"  
	echo "& \\multirow{2}{*}{\\textbf{\\begin{tabular}[c]{@{}l@{}}Net\\\\ Ld\\end{tabular}}}"
	echo "& \\multicolumn{4}{c|}{\\textbf{RxFcsErrors}}"              
	echo "& \\multicolumn{4}{c|}{\\textbf{RxSeqErr}}"           
	echo "& \\multicolumn{4}{c|}{\\textbf{RxMisErr}}"             
	echo "& \\multicolumn{4}{c|}{\\textbf{RxPldErr}}"           
	echo "& \\multicolumn{4}{c|}{\\textbf{RxBer}}"           
	echo "& \\multicolumn{4}{c|}{\\textbf{LatencyAvg (us)}}"          
	echo "& \\multicolumn{4}{c|}{\\textbf{LatencyMin (us)}}"  
	echo "& \\multicolumn{4}{c|}{\\textbf{LatencyMax (us)}}"     
	echo "\\\\" 
	echo "\\cline{3-34}" 
	echo "  & "
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "\\\\ "
	echo "\\hline"
}

function texLimitTableClose() {
	echo "\\hline"
	echo "\\end{tabular}"
	echo "\\end{minipage}"
	echo "\\end{table}"
}

function texFullTableOpen() {
	local caption="$1"
	
	echo "\\begin{table}[!bp]"
 	echo "\\centering"
	echo "  \\rotatebox{90}{%"
    echo "\\begin{minipage}{0.85\\textheight}"
    echo "\\def\\arraystretch{0.9}"
	echo "      \\small\\centering"
	echo "      \\setlength{\\tabcolsep}{1.0mm}"
	echo "      \\scriptsize"
	echo "      \\centering"
	echo "      \\caption{$caption}"
#    echo "  \\label{my-label}" 
	echo "\\begin{tabular}{|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "r|r|r|r|"
	echo "}"
	echo "\\hline"
	echo "\\multirow{2}{*}{\\textbf{\\begin{tabular}[c]{@{}l@{}}Frm\\\\ Size\\end{tabular}}}"  
	echo "& \\multirow{2}{*}{\\textbf{\\begin{tabular}[c]{@{}l@{}}Net\\\\ Ld\\end{tabular}}}"
	echo "& \\multicolumn{4}{c|}{\\textbf{RxFcsErrors}}"              
	echo "& \\multicolumn{4}{c|}{\\textbf{RxSeqErr}}"           
	echo "& \\multicolumn{4}{c|}{\\textbf{RxMisErr}}"             
	echo "& \\multicolumn{4}{c|}{\\textbf{RxPldErr}}"           
	echo "& \\multicolumn{4}{c|}{\\textbf{RxBer}}"           
	echo "& \\multicolumn{4}{c|}{\\textbf{LatencyAvg (us)}}"          
	echo "& \\multicolumn{4}{c|}{\\textbf{LatencyMin (us)}}"  
	echo "& \\multicolumn{4}{c|}{\\textbf{LatencyMax (us)}}"     
	echo "\\\\" 
	echo "\\cline{3-34}" 
	echo "  & "
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "  & P0 & P1 & P2 & P3"
	echo "\\\\ "
	echo "\\hline"
}

function texFullTableClose() {
	echo "\\hline"
	echo "\\end{tabular}"
	echo "\\end{minipage}"
	echo "}"
	echo "\\end{table}"
}

function texFullTableRow() {
	local -a rowData=("${!1}")
	for rowIdx in ${!rowData[@]} ; do
		if [ "$rowIdx" != "0" ] ; then echo -n " & "; fi
		echo -n "${rowData[$rowIdx]}" 
	done
	echo " \\\\"
}


MAX_ROW_PER_TABLE=50

function transposeDataForFullTable () {

	local frmSize=0
	local netLoad=0
	local n=0
	
	
	echo >$dataFileTransposed
	local lineCnt=`wc -l  $dataFile | grep -o ^[0-9]*`
	
	while read line  ; do
		OLDIFS=$IFS
		IFS=" " read -a tokens <<< "$( echo $line )"
		IFS=$OLDIFS
		
		if [[ ${tokens[0]} = [0-3]*  ]] ; then
			port=${tokens[${plotDataIdx[$tkIdxPort]}]}
			frmSize=${tokens[${plotDataIdx[$tkIdxFrameLength]}]}
			netLoad=${tokens[${plotDataIdx[$tkIdxNetLoad]}]}
			rxFcsErrors[$port]=${tokens[${plotDataIdx[$tkIdxRxFcsErrors]}]}
			rxSeqErr[$port]=${tokens[${plotDataIdx[$tkIdxRxSeqErr]}]}
			rxMisErr[$port]=${tokens[${plotDataIdx[$tkIdxRxMisErr]}]}
			rxPldErr[$port]=${tokens[${plotDataIdx[$tkIdxRxPldErr]}]}
			rxBer[$port]=${tokens[${plotDataIdx[$tkIdxRxBer]}]}
			latencyAvg[$port]=${tokens[${plotDataIdx[$tkIdxLatencyAvg]}]}
			latencyMin[$port]=${tokens[${plotDataIdx[$tkIdxLatencyMin]}]}
			latencyMax[$port]=${tokens[${plotDataIdx[$tkIdxLatencyMax]}]}
			if [ "$port" -eq  "3" ] ; then
				str="$frmSize $netLoad"
				for i in `seq 0 3` ; do str+=" ${rxFcsErrors[$i]}"; done 		 
				for i in `seq 0 3` ; do str+=" ${rxSeqErr[$i]}"; done 		 
				for i in `seq 0 3` ; do str+=" ${rxMisErr[$i]}"; done 		 
				for i in `seq 0 3` ; do str+=" ${rxPldErr[$i]}"; done 		 
				for i in `seq 0 3` ; do str+=" "; str+=`echo "scale=2; ${rxBer[$i]}/1" | bc`; done 		 
				for i in `seq 0 3` ; do str+=" "; str+=`echo "scale=1; ${latencyAvg[$i]}/1" | bc`; done 		 
				for i in `seq 0 3` ; do str+=" "; str+=`echo "scale=1; ${latencyMin[$i]}/1" | bc`; done 		 
				for i in `seq 0 3` ; do str+=" "; str+=`echo "scale=1; ${latencyMax[$i]}/1" | bc`; done 		 
				echo $str >>$dataFileTransposed
			fi
		fi
		n=$(( $n+1 ))
		displayPercentage $lineCnt $n
	done < $dataFile
	clearDisplayPercentage
}

function generateTexFullTables () {
	local caption="$1"
	local line=""
	local tableCount=1
	local rowCount=0

	texFullTableOpen "$caption - part $tableCount"
	while read line  ; do
		OLDIFS=$IFS
		IFS=" " read -a tokens <<< "$( echo $line )"
		IFS=$OLDIFS
			
		if [[ ${tokens[0]} = [0-9]*  ]] ; then 
			rowCount=$(( $rowCount+1 ))
			if [ "$rowCount" -gt "$MAX_ROW_PER_TABLE" ] ; then 	
				texFullTableClose
				tableCount=$(( $tableCount+1))
				texFullTableOpen "$caption - part $tableCount"
				rowCount=0
			fi
			texFullTableRow  tokens[@] 
		fi 
	done < $dataFileTransposed
	texFullTableClose
}


function generateTexFullTable() {
	>&2 echo " Transpose data ..."
	transposeDataForFullTable
	
	pf="rawData"
	of="../$pf.tex"
	rm -f $of
	>&2 echo " Generating table  $of"
	generateTexFullTables "$dataCollectionName" >$of
}

function main () {
	>&2 echo "Generate Latex tables"
	scanData
	#plotDataIdx=( [0]=0 [1]=1 [2]=2 [3]=3 [4]=4 [5]=5 [6]=6 [7]=7 [8]=8 [9]=9 [10]=10 )
	generateTexFullTable
} 


main

