#!/bin/sh

source schedLib.sh

#
# Options
#
STREAMS_PER_PORT=1 # default

while getopts "s:" arg; do
  case $arg in
    s)
      STREAMS_PER_PORT=$OPTARG
      ;;
  esac
done

SCHED_NAME="sched_fp_incr_fixed_s$STREAMS_PER_PORT"
OUTPUT=$SCHED_NAME.xsch

rates=( 50   80  95   100 )
packetSizes="64 65 700 701 1521 1522"
bursTime=300

schedHeader $SCHED_NAME
# Learning process
schedStreamCustom true "" "PS_PACKETLIMIT 10"
schedStreamCustom true "" "PS_PACKETLENGTH FIXED 64 64"

# Synchronize logging 
schedPortClearStats true ""
schedWait 20.0 

#
schedStreamCustom true "" "PS_PACKETLIMIT 0" # Unlimited duration
for packetSize in $packetSizes; do
	schedStreamCustom true "" "PS_PACKETLENGTH FIXED $packetSize $packetSize"
	for i in "${!rates[@]}"; do
		rate=${rates[$i]}
		ratePerPort=`echo "scale=2; $rate/$STREAMS_PER_PORT" | bc`
		schedStreamSetParameter true "" PS_RATEFRACTION $ratePerPort
		schedPortClearStats true ""
		# Wait a little bit for logs
		schedWait 6.0
		schedPortStartTraffic true ""
		schedWait $bursTime
		schedPortStopTraffic true ""		
	done
done
schedFooter
