
OUTPUT="/dev/stdout"

SCHED_NAME="SchedName"
CHASSIS_ID="b256ebe4-f6f8-4d42-a0bb-bf5e8ceb8b45"

function schedHeader() {
	SCHED_NAME=$1
	echo "{"
  	echo "\"Operations\": ["
} > $OUTPUT

function schedFooter() {
  	echo "],"
	echo "\"ParentId\": \"\","
  	echo "\"DisplayName\": \"$SCHED_NAME\""
	echo "}"
} >> $OUTPUT

function getPortTaget() {
	local str=$1
	local ret="{"
	local streamId=0
	local moduleId=0
	local portId=0
	if [ -z "$str" ] ; then echo ""; return 0; fi
	if [[ $str =~ ^S ]] ; then
		portId=`echo $str| grep -o -e [0-9] | sed '3q;d'`
	    moduleId=`echo $str| grep -o -e [0-9] | sed '2q;d'`
		streamId=`echo $str| grep -o -e [0-9] | sed '4q;d'`
		ret+="\"StreamId\": $streamId,"
	else
		portId=`echo $str| grep -o -e [0-9] | sed '4q;d'`
	    moduleId=`echo $str| grep -o -e [0-9] | sed '3q;d'`
	fi
	ret+="\"ChassisId\": \"$CHASSIS_ID\","
	ret+="\"ModuleIndex\": $moduleId,"
    ret+="\"PortIndex\": $portId" 
	ret+="}"
	echo $ret
}

function getPortTagetList() {
	local str=$1

	if [ -z "$str" ] ; then echo ""; return 0; fi
	
	declare -a tokens
	OLDIFS=$IFS
	IFS="," read -r -a tokens <<< "$str"
	IFS=$OLDIFS
	
	for tk in ${tokens[@]} ; do
		 getPortTaget $tk
		 echo ","
	done
}

function schedStreamTemplate() { 
	local operType="$1"
	local operValue="$2"
	local displayName="$3"
    local allTargets="$4"
    local streamTargets="$5"

    echo "{"
    echo "  \"OperType\": \"$operType\","
    echo "  \"ParamType\": 0,"
    if [ -z "$operValue" ] ; then
	    echo "  \"OperValue\": null,"
  	else 
  		echo "  \"OperValue\": \"$operValue\","
  	fi
  	local pt=$( getPortTagetList $streamTargets ) 
    echo "  \"PortTargetList\": [$pt],"
    echo "  \"StreamTargetList\": [$pt],"
    echo "  \"AllTargetsSelected\": $allTargets,"
    echo "  \"DisplayName\": \"$displayName\","
    echo "  \"Operations\": [],"
    echo "  \"ParentId\": \"\""
    echo "},"

}

function schedPortTemplate() {
	schedStreamTemplate "$1" "$2" "$3" "$4" "$5"
} 

function schedPortStopTraffic() {
	schedPortTemplate StopTraffic "" "Stop Traffic" "$1" "$2"
} >> $OUTPUT
    
function schedPortStartTraffic() {
	schedPortTemplate StartTraffic "" "Start Traffic" "$1" "$2"
} >> $OUTPUT

function schedPortClearStats() {
	schedPortTemplate ClearStats "" "Clear Statistics" "$1" "$2"
} >> $OUTPUT
    
function schedStreamEnableStream() {
	schedStreamTemplate EnableStream "" "Enable Stream" "$1" "$2"
} >> $OUTPUT

function schedStreamCustom() {
	schedStreamTemplate CustomStreamCommand "$3" "Enable Stream" "$1" "$2"
} >> $OUTPUT


function schedStreamSetParameter() {
    local allTargets=$1
    local streamTargets=$2
    local streamParameter=$3
    local steamParameterValue=$4

    echo "{"
    echo "  \"OperType\": \"SetParamValue\","
    echo "  \"ParamType\": \"$streamParameter\","
    echo "  \"OperValue\": $steamParameterValue,"
  	local pt=$( getPortTagetList $streamTargets ) 
    echo "  \"PortTargetList\": [$pt],"
    echo "  \"StreamTargetList\": [$pt],"
    echo "  \"AllTargetsSelected\": $allTargets,"
    echo "  \"DisplayName\": \"Set Parameter Value\","
    echo "  \"Operations\": [],"
    echo "  \"ParentId\": \"\""
    echo "},"
} >> $OUTPUT


function schedWait() {
	local seconds=$1

    echo "{"
    echo "  \"OperType\": \"Wait\","
    echo "  \"ParamType\": 0,"
    echo "  \"OperValue\": $seconds,"
    echo "  \"PortTargetList\": [],"
    echo "  \"StreamTargetList\": [],"
    echo "  \"AllTargetsSelected\": true,"
    echo "  \"DisplayName\": \"Wait Period\","
    echo "  \"Operations\": [],"
    echo "  \"ParentId\": \"\""
    echo "},"
} >> $OUTPUT
   


